## contextfree 2.2+dfsg1

=== Makefile ===

all: cfdg


#
# Dirs
#

OBJ_DIR = objs

COMMON_DIR = src-common
UNIX_DIR = src-unix
DERIVED_DIR = $(OBJ_DIR)
AGG_DIR = src-agg

SRC_DIRS = $(COMMON_DIR) $(UNIX_DIR) $(DERIVED_DIR) $(AGG_DIR)/src
vpath %.cpp $(SRC_DIRS)
vpath %.c	$(SRC_DIRS)

INC_DIRS = $(COMMON_DIR) $(UNIX_DIR) $(DERIVED_DIR) $(AGG_DIR)/include $(COMMON_DIR)/agg-extras

#
# Sources and Objects
#

COMMON_SRCS = cfdg.cpp Rand48.cpp makeCFfilename.cpp \
	cfdgimpl.cpp renderimpl.cpp builder.cpp shape.cpp \
	yglue.cpp variation.cpp countable.cpp tempfile.cpp \
	aggCanvas.cpp HSBColor.cpp SVGCanvas.cpp \
	primShape.cpp bounds.cpp shape.cpp shapeSTL.cpp tiledCanvas.cpp

UNIX_SRCS = pngCanvas.cpp posixSystem.cpp main.cpp posixTimer.cpp \
    posixVersion.cpp

DERIVED_SRCS = lex.yy.c y.tab.c

AGG_SRCS = agg_trans_affine.cpp agg_curves.cpp agg_vcgen_contour.cpp \
    agg_vcgen_stroke.cpp agg_bezier_arc.cpp

SRCS = $(COMMON_SRCS) $(UNIX_SRCS) $(DERIVED_SRCS) $(AGG_SRCS)
OBJS = $(patsubst %.c,$(OBJ_DIR)/%.o, \
	$(patsubst %.cpp,$(OBJ_DIR)/%.o,$(SRCS)))
DEPS = $(patsubst %.o,%.d,$(OBJS))

deps: $(OBJ_DIR) $(DEPS)
include $(DEPS)

$(OBJS): $(OBJ_DIR)/Sentry

#
# Executable
#
# Under Mac OS X replace $(LINK.o) with g++.
# Under Cygwin replace strip $@ with strip $@.exe

cfdg: $(OBJS)
	$(LINK.o) $^ -L/usr/local/lib -lstdc++ -lpng -lz -fexceptions -o $@
	strip $@


#
# Derived
#

$(DERIVED_DIR)/lex.yy.c: $(COMMON_DIR)/cfdg.l
	flex -t $^ > $@

$(DERIVED_DIR)/y.tab.h: $(DERIVED_DIR)/y.tab.c
$(DERIVED_DIR)/y.tab.c: $(COMMON_DIR)/cfdg.y
	cd $(DERIVED_DIR); yacc -d ../$(COMMON_DIR)/cfdg.y

$(OBJ_DIR)/lex.yy.o: $(DERIVED_DIR)/y.tab.h

#
# Utility
#

clean :
	rm -f $(OBJ_DIR)/*
	rm -f cfdg

distclean: clean
	rmdir $(OBJ_DIR)

$(OBJ_DIR)/Sentry :
	mkdir -p $(OBJ_DIR) 2> /dev/null || true
	touch $@

#
# Tests
#

RTEST_CFDG = input/rendering-tests.cfdg
OUTPUT_DIR = output

rtests: $(OUTPUT_DIR)/rtest-700.png $(OUTPUT_DIR)/rtest-2k.png

$(OUTPUT_DIR)/rtest-700.png: cfdg $(RTEST_CFDG)
	./cfdg -s 700 $(RTEST_CFDG) $@
$(OUTPUT_DIR)/rtest-2k.png: cfdg $(RTEST_CFDG)
	./cfdg -s 2000 $(RTEST_CFDG) $@

#
# Rules
#

CPPFLAGS += $(patsubst %,-I%,$(INC_DIRS))
CPPFLAGS += -O3 -Wall
#CPPFLAGS += -ggdb

$(OBJ_DIR)/%.o : %.cpp
	$(COMPILE.cpp) $(OUTPUT_OPTION) $<

$(OBJ_DIR)/%.o : %.c
	$(COMPILE.c) $(OUTPUT_OPTION) $<

$(OBJ_DIR)/%.d : %.cpp
	mkdir -p $(OBJ_DIR) 2> /dev/null || true
	set -e; $(COMPILE.cpp) -MM $< \
	| sed 's,\(.*\.o\)\( *:\),$(OBJ_DIR)/\1 $@\2,g' > $@; \
	[ -s $@ ] || rm -f $@

$(OBJ_DIR)/%.d : %.c
	mkdir -p $(OBJ_DIR) 2> /dev/null || true
	set -e; $(COMPILE.c) -MM $< \
	| sed 's,\(.*\.o\)\( *:\),$(OBJ_DIR)/\1 $@\2,g' > $@; \
	[ -s $@ ] || rm -f $@

$(OBJ_DIR)/y.tab.d:

$(OBJ_DIR)/lex.yy.d:

=== src-win/derived/Makefile ===
# Build the common derived files

DERIVED = lex.yy.c y.tab.c y.tab.h

all: $(DERIVED)

lex.yy.c: ../../src-common/cfdg.l
	flex ../../src-common/cfdg.l

y.tab.c y.tab.h: ../../src-common/cfdg.y
	yacc -d ../../src-common/cfdg.y

clean:
	rm $(DERIVED)

=== debian/changelog ===
contextfree (2.2+dfsg1-2.1) unstable; urgency=low

  * Non-maintainer upload; ACKed by the maintainer, see #664418.
  * Remove deprecated dpatch and upgrade to packaging format "3.0 quilt"
    (Closes: #664418).
  * Update to Standards-Version to 3.9.3.1 and debhelper to 9.
  * Add build-arch and build-indep targets; use dh_prep in rules file.

 -- Jari Aalto <jari.aalto@cante.net>  Wed, 04 Apr 2012 19:46:02 +0300

contextfree (2.2+dfsg1-2) unstable; urgency=low

  * Added patch 03_link_against_libm to fix FTBFS with --no-add-needed, which
    is the default when building using binutils-gold.  Thanks to Ilya Barygin
    <barygin@gmail.com>, who fixed this in Ubuntu (closes: #554116).
  * Added ${misc:Depends} to the depends of the contextfree binary package.
  * Updated Standards-Version to 3.9.1.

 -- Bram Senders <bram@luon.net>  Fri, 14 Jan 2011 19:37:13 +0100

contextfree (2.2+dfsg1-1) unstable; urgency=low

  * Removed src-net/ directory from upstream source, which contained files
    which are undistributable according to the DFSG.
  * Updated debian/README.source to note this fact.

 -- Bram Senders <bram@luon.net>  Thu, 12 Mar 2009 16:42:39 +0100

contextfree (2.2-2) experimental; urgency=low

  * Added patch 02_do_not_link_against_libz, to not uselessly link agains libz
    (thanks to dpkg-shlibdeps for the warning).

 -- Bram Senders <bram@luon.net>  Mon, 09 Feb 2009 22:50:20 +0100

contextfree (2.2-1) experimental; urgency=low

  * New upstream release (thanks to Paul van Tilburg and Joachim Breitner for
    motivating me to actually package this!).
  * Dropped patch 01_add_headers; fixed upstream.
  * Updated manpage for cfdg 2.2.
  * Update Standards-Version to 3.8.0.  This requires contextfree to be built
    against an external version of libagg instead of the included sources, so
    added patch 01_use_external_libagg to do that.  Note that we are still
    using the included libagg header files instead of the external ones, as the
    included copy has modifications that are needed for building contextfree.
    This has also been noted in debian/README.source.
  * Added libagg-dev to Build-Depends (because of the above patch).
  * Updated copyright years in debian/copyright.
  * Initial upload to Debian (closes: #461751).

 -- Bram Senders <bram@luon.net>  Sat, 07 Feb 2009 13:41:02 +0100

contextfree (2.2~beta2-1) unstable; urgency=low

  * New upstream beta release.
  * Dropped patch 01_int_for_getopt; fixed upstream.
  * Added patch 01_add_headers for missing headers to make gcc happy.

 -- Bram Senders <bram@luon.net>  Wed, 24 Sep 2008 20:51:58 +0200

contextfree (2.1-1) unstable; urgency=low

  * Initial creation of Debian package.

 -- Bram Senders <bram@luon.net>  Sun, 20 Jan 2008 14:42:26 +0100

=== debian/control ===
Source: contextfree
Section: graphics
Priority: extra
Maintainer: Bram Senders <bram@luon.net>
Uploaders: Paul van Tilburg <paulvt@debian.org>
Build-Depends: debhelper (>= 9), flex, bison, libpng12-dev, libagg-dev
Standards-Version: 3.9.3.1
Homepage: http://contextfreeart.org/

Package: contextfree
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: image generator based on context-free grammars
 Context Free is a program that produces images based on context-free grammars.
 These grammars are sets of non-deterministic rules that determine what an
 image should look like.  The resulting images often resemble a mix of
 spirograph drawings, fractals and abstract art.
 .
 Context Free can generate images with millions of shapes, in PNG (up to 100
 megapixels) or SVG format.  It can also produce animations.  Many example
 images are included.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
# Modified for the contextfree package by Bram Senders.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1



build-arch: build
build-indep: build

build: build-stamp
build-stamp:
	dh_testdir
	$(MAKE)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	$(MAKE) clean
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress -X.cfdg
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## contextfree 3.0.5%2Bdfsg1

=== debian/changelog ===
contextfree (3.0.5+dfsg1-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Build using the default GCC. Closes: #751304.

 -- Matthias Klose <doko@debian.org>  Sat, 09 Aug 2014 14:31:18 +0200

contextfree (3.0.5+dfsg1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "FTBFS: undefined reference to `__sync_bool_compare_and_swap_8'"
    Add 04-gcc-4.8-atomic.patch
    Patch by Aurelien Jarno
    Closes: #733456

 -- Anibal Monsalve Salazar <anibal@debian.org>  Tue, 04 Mar 2014 13:34:23 +0000

contextfree (3.0.5+dfsg1-2) unstable; urgency=low

  * Added patch 03_fix-arch-native.patch; fixes FTBFS on several architectures.
    Thanks to Roland Stigge for the patch (Closes: #731005).
  * Update Standards-Version to 3.9.5 (no changes required).

 -- Bram Senders <bram@luon.net>  Mon, 02 Dec 2013 22:04:22 +0100

contextfree (3.0.5+dfsg1-1) unstable; urgency=low

  * New upstream release (Closes: #720699).
  * Acknowledge NMU by Jari Aalto (thanks for helping!)
  * Change Build-Depends on libpng12-dev to libpng-dev (Closes: #662291).
  * Port debian/rules to using dh.
  * Add debian/repack.sh script based on that of owncloud Debian package.
  * Add debian/watch file, that also calls the repack script.
  * Drop patch 01_use_external_libagg.patch.
    Building against external libagg does not work anymore, so just use the
    included copy.  Also document this in debian/README.source.
  * Refresh patch 02_do_not_link_against_libz.patch.
  * Drop patch 03_link_against_libm.patch.
    Upstream now links against libm in Makefile.
  * Remove src-ffmpeg/ from upstream source tarball.
    Reasons documented in debian/README.source.
  * Add patch 01_disable_ffmpeg_support.patch.
    Disable building against FFmpeg.
  * Update copyright years in debian/copyright.
  * Update Standards-Version to 3.9.4 (no changes required).
  * Update manpage to take new upstream options into account.

 -- Bram Senders <bram@luon.net>  Thu, 28 Nov 2013 16:17:33 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: extra
 Maintainer: Bram Senders <bram@luon.net>
 Uploaders: Paul van Tilburg <paulvt@debian.org>
-Build-Depends: debhelper (>= 9), flex, bison, libpng12-dev, libagg-dev
-Standards-Version: 3.9.3.1
+Build-Depends: debhelper (>= 9), flex, bison, libpng-dev
+Standards-Version: 3.9.5
 Homepage: http://contextfreeart.org/
 
 Package: contextfree

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# .cfdg example files should not be compressed
override_dh_compress:
	dh_compress -X.cfdg

# "make test" fails (there is no explicit "test" target in the Makefile, but it
# is matched by one of the rules), so override dh_auto_test to not run
override_dh_auto_test:

## contextfree 3.0.5+dfsg1

=== Makefile ===

all: cfdg


#
# Dirs
#

OBJ_DIR = objs

COMMON_DIR = src-common
UNIX_DIR = src-unix
DERIVED_DIR = $(OBJ_DIR)
AGG_DIR = src-agg
FFMPEG_DIR = src-ffmpeg

SRC_DIRS = $(COMMON_DIR) $(UNIX_DIR) $(DERIVED_DIR) $(AGG_DIR)/src
vpath %.cpp $(SRC_DIRS)

INC_DIRS = $(COMMON_DIR) $(UNIX_DIR) $(DERIVED_DIR) $(AGG_DIR)/include $(COMMON_DIR)/agg-extras $(FFMPEG_DIR)/include

#
# Library directories for FFmpeg and libpng
#

LIB_DIRS = $(FFMPEG_DIR)/lib /usr/local/lib

#
# Sources and Objects
#

COMMON_SRCS = cfdg.cpp Rand64.cpp makeCFfilename.cpp \
	cfdgimpl.cpp renderimpl.cpp builder.cpp shape.cpp \
	variation.cpp countable.cpp tempfile.cpp \
	aggCanvas.cpp HSBColor.cpp SVGCanvas.cpp \
	primShape.cpp bounds.cpp shape.cpp shapeSTL.cpp tiledCanvas.cpp \
	astexpression.cpp astreplacement.cpp pathIterator.cpp \
	stacktype.cpp CmdInfo.cpp abstractPngCanvas.cpp ast.cpp

UNIX_SRCS = pngCanvas.cpp posixSystem.cpp main.cpp posixTimer.cpp \
    posixVersion.cpp

DERIVED_SRCS = lex.yy.cpp cfdg.tab.cpp

AGG_SRCS = agg_trans_affine.cpp agg_curves.cpp agg_vcgen_contour.cpp \
    agg_vcgen_stroke.cpp agg_bezier_arc.cpp agg_color_rgba.cpp

LIBS = stdc++ png z m

#
# FFmpeg support
#
# Comment out these lines to disable FFmpeg support
#

COMMON_SRCS += ffCanvas.cpp
LIBS += avformat avcodec avutil

#
# Uncomment out this line to disable FFmpeg support
#

# COMMON_SRCS += ffCanvasDummy.cpp

SRCS = $(COMMON_SRCS) $(UNIX_SRCS) $(DERIVED_SRCS) $(AGG_SRCS)
OBJS = $(patsubst %.cpp,$(OBJ_DIR)/%.o,$(SRCS))
DEPS = $(patsubst %.o,%.d,$(OBJS))

LINKFLAGS += $(patsubst %,-L%,$(LIB_DIRS))
LINKFLAGS += $(patsubst %,-l%,$(LIBS))
LINKFLAGS += -fexceptions

deps: $(OBJ_DIR) $(DEPS)
include $(DEPS)

$(OBJS): $(OBJ_DIR)/Sentry

#
# Executable
#
# Under Mac OS X replace $(LINK.o) with g++.
# Under Cygwin replace strip $@ with strip $@.exe

cfdg: $(OBJS)
	$(LINK.o) $^ $(LINKFLAGS) -o $@
	strip $@


#
# Derived
#

$(DERIVED_DIR)/lex.yy.cpp: $(COMMON_DIR)/cfdg.l
	flex -o $@ $^

$(DERIVED_DIR)/cfdg.tab.hpp: $(DERIVED_DIR)/cfdg.tab.cpp
$(DERIVED_DIR)/cfdg.tab.cpp: $(COMMON_DIR)/cfdg.ypp
	bison -o $(DERIVED_DIR)/cfdg.tab.cpp $(COMMON_DIR)/cfdg.ypp

$(OBJ_DIR)/lex.yy.o: $(DERIVED_DIR)/cfdg.tab.hpp

#
# Utility
#

clean :
	rm -f $(OBJ_DIR)/*
	rm -f cfdg

distclean: clean
	rmdir $(OBJ_DIR)

$(OBJ_DIR)/Sentry :
	mkdir -p $(OBJ_DIR) 2> /dev/null || true
	touch $@

#
# Tests
#

RTEST_CFDG = input/rendering-tests.cfdg
OUTPUT_DIR = output

rtests: $(OUTPUT_DIR)/rtest-700.png $(OUTPUT_DIR)/rtest-2k.png

$(OUTPUT_DIR)/rtest-700.png: cfdg $(RTEST_CFDG)
	./cfdg -s 700 $(RTEST_CFDG) $@
$(OUTPUT_DIR)/rtest-2k.png: cfdg $(RTEST_CFDG)
	./cfdg -s 2000 $(RTEST_CFDG) $@

#
# Rules
#

CPPFLAGS += $(patsubst %,-I%,$(INC_DIRS))
CPPFLAGS += -O3 -Wall -march=native -Wno-parentheses
#CPPFLAGS += -ggdb

$(OBJ_DIR)/%.o : %.cpp
	$(COMPILE.cpp) $(OUTPUT_OPTION) $<

$(OBJ_DIR)/%.d : %.cpp
	mkdir -p $(OBJ_DIR) 2> /dev/null || true
	set -e; $(COMPILE.cpp) -MM $< \
	| sed 's,\(.*\.o\)\( *:\),$(OBJ_DIR)/\1 $@\2,g' > $@; \
	[ -s $@ ] || rm -f $@

$(OBJ_DIR)/cfdg.tab.d:

$(OBJ_DIR)/lex.yy.d:

=== src-win/derived/Makefile ===
# Build the common derived files

DERIVED = lex.yy.cpp cfdg.tab.cpp cfdg.tab.hpp FlexLexer.h

all: $(DERIVED)

lex.yy.cpp FlexLexer.h: ../../src-common/cfdg.l cfdg.tab.hpp
	flex -o lex.yy.cpp ../../src-common/cfdg.l
	cp `which flex | xargs dirname | xargs dirname`/include/FlexLexer.h .

cfdg.tab.cpp cfdg.tab.hpp: ../../src-common/cfdg.ypp
	bison -o cfdg.tab.cpp ../../src-common/cfdg.ypp

clean:
	rm $(DERIVED)

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: Bram Senders <bram@luon.net>
 Uploaders: Paul van Tilburg <paulvt@debian.org>
-Build-Depends: debhelper (>= 9), flex, bison, libpng-dev
+Build-Depends: debhelper (>= 9), flex, bison, libpng-dev, g++-4.8
 Standards-Version: 3.9.5
 Homepage: http://contextfreeart.org/

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,7 @@
 #!/usr/bin/make -f
+
+export CC=gcc-4.8
+export CXX=g++-4.8
 
 %:
 	dh $@

## contextfree 3.0.11.4+dfsg1

=== debian/changelog ===
contextfree (3.0.11.4+dfsg1-1) unstable; urgency=medium

  * New upstream release and new maintainer. (Closes: #770324)
  * Remove src-ffmpeg, src-osx, src-net, src-win, src-net from 
    upstream source tarball. (Closes: #823144)
  * Remove patches 01_disable_ffmpeg_support.patch,
    02_do_not_link_against_libz.patch, 04-gcc-4.8-atomic.patch. 
    All have been fixed in upstream.
  * Context Free depends on the latest version of libagg, which
    has been added to package libagg-dev at version 1:2.4. Added
    patch 02_use_external_libagg.patch to use libagg-dev. src-agg
    has been removed from the upstream tarball.
  * Added libagg-dev to Build-Depends (because of the above patch).
  * Updated Standards-Version to 4.0.1. Priority changed from
    extra to optional. copyright-format URL uses https.
  * Remove debian/repack.sh. Use a Files-Exluded line in
    debian/copyright instead.
  * Add explicit dependence on package libfl-dev as it is a 
    recommended dependence of flex but contextfree requires it.

 -- John Horigan <john@glyphic.com>  Wed, 16 Aug 2017 12:46:24 -0700

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: contextfree
 Section: graphics
-Priority: extra
-Maintainer: Bram Senders <bram@luon.net>
+Priority: optional
+Maintainer: John Horigan <john@glyphic.com>
 Uploaders: Paul van Tilburg <paulvt@debian.org>
-Build-Depends: debhelper (>= 9), flex, bison, libpng-dev, g++-4.8
-Standards-Version: 3.9.5
-Homepage: http://contextfreeart.org/
+Build-Depends: debhelper (>= 9), flex (>= 2.6), bison (>=2:3), libpng-dev, libagg-dev (>= 1:2.4), libfl-dev (>= 2.6)
+Standards-Version: 4.0.1
+Homepage: https://www.contextfreeart.org/index.html
 
 Package: contextfree
 Architecture: any

## contextfree 3.0.11.5%2Bdfsg1

=== debian/changelog ===
contextfree (3.0.11.5+dfsg1-1build1) bionic; urgency=medium

  * No-change rebuild to pick up the shared flex library.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 20 Feb 2018 07:00:56 +0000

contextfree (3.0.11.5+dfsg1-1) unstable; urgency=medium

  * Upstream fix for FTBFS w.r.t. ppc64el. (Closes: #872738)
  * Upstream fix for FTBFS for Alpha in myrandom.h
  * Upstream fix for FTBFS for gnu/Hurd and x32
  * Upstream fix for warnings about [[fallthrough]] and readdir_r
  * Updated Standards-Version to 4.1.0 and debhelper to 10

 -- John Horigan <john@glyphic.com>  Mon, 21 Aug 2017 16:23:29 -0700

## contextfree 3.0.11.5+dfsg1

=== Makefile ===

all: cfdg


#
# Dirs
#

OBJ_DIR = objs

COMMON_DIR = src-common
UNIX_DIR = src-unix
DERIVED_DIR = $(OBJ_DIR)
AGG_DIR = src-agg
FFMPEG_DIR = src-ffmpeg

SRC_DIRS = $(COMMON_DIR) $(UNIX_DIR) $(DERIVED_DIR) $(AGG_DIR)/src
vpath %.cpp $(SRC_DIRS)
vpath %.cfdg input

INC_DIRS = $(COMMON_DIR) $(UNIX_DIR) $(DERIVED_DIR) $(COMMON_DIR)/agg-extras $(FFMPEG_DIR)/include
INC_DIRS += /usr/local/include

#
# Installation directories
#

prefix = /usr/local

BIN_DIR = $(DESTDIR)$(prefix)/bin
MAN_DIR = $(DESTDIR)$(prefix)/share/man

#
# Library directories for FFmpeg and libpng
#

LIB_DIRS = $(FFMPEG_DIR)/lib /usr/local/lib

#
# Sources and Objects
#

COMMON_SRCS = cfdg.cpp Rand64.cpp makeCFfilename.cpp \
	cfdgimpl.cpp renderimpl.cpp builder.cpp shape.cpp \
	variation.cpp tempfile.cpp commandLineSystem.cpp \
	aggCanvas.cpp HSBColor.cpp SVGCanvas.cpp rendererAST.cpp \
	primShape.cpp bounds.cpp shape.cpp shapeSTL.cpp tiledCanvas.cpp \
	astexpression.cpp astreplacement.cpp pathIterator.cpp \
	stacktype.cpp CmdInfo.cpp abstractPngCanvas.cpp ast.cpp

UNIX_SRCS = pngCanvas.cpp posixSystem.cpp main.cpp posixTimer.cpp \
    posixVersion.cpp

DERIVED_SRCS = cfdg.tab.cpp lex.yy.cpp

AGG_SRCS = agg_trans_affine.cpp agg_curves.cpp agg_vcgen_contour.cpp \
    agg_vcgen_stroke.cpp agg_bezier_arc.cpp agg_color_rgba.cpp

INPUT_SRCS = ciliasun_v2.cfdg demo1_v2.cfdg demo2_v2.cfdg funky_flower_v2.cfdg \
    i_curves_v2.cfdg i_pix_v2.cfdg i_polygons_v2.cfdg lesson2_v2.cfdg \
    lesson_v2.cfdg mtree_v2.cfdg octopi_v2.cfdg quadcity_v2.cfdg rose_v2.cfdg \
    sierpinski_v2.cfdg snowflake_v2.cfdg tangle_v2.cfdg triples_v2.cfdg \
    underground_v2.cfdg weighting_demo_v2.cfdg welcome_v2.cfdg ziggy_v2.cfdg \
    ciliasun.cfdg demo1.cfdg demo2.cfdg funky_flower.cfdg i_curves.cfdg \
    i_pix.cfdg i_polygons.cfdg lesson2.cfdg lesson.cfdg mtree.cfdg \
    octopi.cfdg quadcity.cfdg rose.cfdg sierpinski.cfdg snowflake.cfdg \
    tangle.cfdg triples.cfdg underground.cfdg weighting_demo.cfdg \
    welcome.cfdg ziggy.cfdg


LIBS = png m

# Use the first one for clang and the second one for gcc
ifeq ($(shell uname -s), Darwin)
  LIBS += c++
else
  LIBS += stdc++ atomic
endif

#
# FFmpeg support
#
# Uncomment these lines to enable FFmpeg support
#

# COMMON_SRCS += ffCanvas.cpp
# LIBS += avformat avcodec swscale swresample avutil z m x264 pthread dl

#
# Comment out this line to enable FFmpeg support
#

COMMON_SRCS += ffCanvasDummy.cpp
SRCS = $(DERIVED_SRCS) $(COMMON_SRCS) $(UNIX_SRCS)

#
# Configuration for local AGG
#
SRCS += $(AGG_SRCS)
INC_DIRS += $(AGG_DIR) $(AGG_DIR)/agg2


#
# Configuration for system AGG
#
#LIBS += agg


OBJS = $(patsubst %.cpp,$(OBJ_DIR)/%.o,$(SRCS))
DEPS = $(patsubst %.o,%.d,$(OBJS))

LINKFLAGS += $(patsubst %,-L%,$(LIB_DIRS))
LINKFLAGS += $(patsubst %,-l%,$(LIBS))
LINKFLAGS += -fexceptions

deps: $(OBJ_DIR) $(DEPS)

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
ifneq ($(MAKECMDGOALS),src-common/examples.h)
include $(DEPS)
endif
endif
endif

$(OBJS): $(OBJ_DIR)/Sentry

#
# Executable
#
# Under Cygwin replace strip $@ with strip $@.exe

cfdg: $(OBJS)
	$(LINK.o) $^ $(LINKFLAGS) -o $@
	strip $@


#
# Derived
#

$(DERIVED_DIR)/lex.yy.cpp: $(COMMON_DIR)/cfdg.l
	flex -o $@ $^

$(DERIVED_DIR)/cfdg.tab.hpp: $(DERIVED_DIR)/cfdg.tab.cpp
$(DERIVED_DIR)/location.hh: $(DERIVED_DIR)/cfdg.tab.cpp
$(DERIVED_DIR)/cfdg.tab.cpp: $(COMMON_DIR)/cfdg.ypp $(OBJ_DIR)/Sentry
	bison -o $(DERIVED_DIR)/cfdg.tab.cpp $(COMMON_DIR)/cfdg.ypp

$(OBJ_DIR)/lex.yy.o: $(DERIVED_DIR)/cfdg.tab.hpp

src-common/examples.h: $(INPUT_SRCS)
	python makeexamples.py $(INPUT_SRCS) > src-common/examples.h

#
# Utility
#

.PHONY: clean distclean install uninstall
clean :
	rm -f $(OBJ_DIR)/*
	rm -f cfdg

distclean: clean
	rmdir $(OBJ_DIR) 2> /dev/null || true
	rm -fr output 2> /dev/null || true

$(OBJ_DIR)/Sentry :
	mkdir -p $(OBJ_DIR) 2> /dev/null || true
	touch $@

install: cfdg cfdg.1
	install -d $(BIN_DIR) $(MAN_DIR)/man1
	install -m 755 cfdg $(BIN_DIR)
	install -m 644 cfdg.1 $(MAN_DIR)/man1

uninstall:
	-rm -f $(BIN_DIR)/cfdg
	-rm -f $(MAN_DIR)/man1/cfdg.1

#
# Tests
#

.PHONY: test check
test: cfdg
	./runtests.sh

check: cfdg
	./runtests.sh

#
# Rules
#

CPPFLAGS += $(patsubst %,-I%,$(INC_DIRS))
CPPFLAGS += -O2 -Wall -Wextra -march=native -Wno-parentheses -std=c++14
#CPPFLAGS += -g

# Add this for clang
ifeq ($(shell uname -s), Darwin)
  CPPFLAGS += -stdlib=libc++
endif

$(OBJ_DIR)/%.o : %.cpp
	$(COMPILE.cpp) $(OUTPUT_OPTION) $<

$(OBJ_DIR)/%.d : %.cpp $(OBJ_DIR)/location.hh
	mkdir -p $(OBJ_DIR) 2> /dev/null || true
	set -e; $(COMPILE.cpp) -MM $< \
	| sed 's,\(.*\.o\)\( *:\),$(OBJ_DIR)/\1 $@\2,g' > $@; \
	[ -s $@ ] || rm -f $@

$(OBJ_DIR)/cfdg.tab.d:
	mkdir -p $(OBJ_DIR) 2> /dev/null || true

$(OBJ_DIR)/lex.yy.d:
	mkdir -p $(OBJ_DIR) 2> /dev/null || true

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: John Horigan <john@glyphic.com>
 Uploaders: Paul van Tilburg <paulvt@debian.org>
-Build-Depends: debhelper (>= 9), flex (>= 2.6), bison (>=2:3), libpng-dev, libagg-dev (>= 1:2.4), libfl-dev (>= 2.6)
-Standards-Version: 4.0.1
+Build-Depends: debhelper (>= 10), flex (>= 2.6), bison (>=2:3), libpng-dev, libagg-dev (>= 1:2.4), libfl-dev (>= 2.6)
+Standards-Version: 4.1.0
 Homepage: https://www.contextfreeart.org/index.html
 
 Package: contextfree

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_usrlocal:

override_dh_auto_install:

# .cfdg example files should not be compressed
override_dh_compress:
	dh_compress -X.cfdg

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

## contextfree 3.1+dfsg1

=== Makefile ===
--- 
+++ 
@@ -46,7 +46,8 @@
 	aggCanvas.cpp HSBColor.cpp SVGCanvas.cpp rendererAST.cpp \
 	primShape.cpp bounds.cpp shape.cpp shapeSTL.cpp tiledCanvas.cpp \
 	astexpression.cpp astreplacement.cpp pathIterator.cpp \
-	stacktype.cpp CmdInfo.cpp abstractPngCanvas.cpp ast.cpp
+	stacktype.cpp CmdInfo.cpp abstractPngCanvas.cpp ast.cpp \
+	prettyint.cpp
 
 UNIX_SRCS = pngCanvas.cpp posixSystem.cpp main.cpp posixTimer.cpp \
     posixVersion.cpp
@@ -72,9 +73,9 @@
 
 # Use the first one for clang and the second one for gcc
 ifeq ($(shell uname -s), Darwin)
-  LIBS += c++
+  LIBS += c++ icucore
 else
-  LIBS += stdc++ atomic
+  LIBS += stdc++ atomic icui18n icuuc icudata
 endif
 
 #
@@ -193,13 +194,14 @@
 # Rules
 #
 
-CPPFLAGS += $(patsubst %,-I%,$(INC_DIRS))
-CPPFLAGS += -O2 -Wall -Wextra -march=native -Wno-parentheses -std=c++14
-#CPPFLAGS += -g
+CXXFLAGS += $(patsubst %,-I%,$(INC_DIRS))
+CXXFLAGS += -O2 -Wall -Wextra -march=native -Wno-parentheses -std=c++14
+CXXFLAGS += -g -D_GLIBCXX_USE_C99_MATH=1
+CPPFLAGS += -DNDEBUG
 
 # Add this for clang
 ifeq ($(shell uname -s), Darwin)
-  CPPFLAGS += -stdlib=libc++
+  CXXFLAGS += -stdlib=libc++
 endif
 
 $(OBJ_DIR)/%.o : %.cpp

=== debian/changelog ===
contextfree (3.1+dfsg1-2) unstable; urgency=medium

  * Use shared library for libagg (Closes: #920920)

 -- John Horigan <john@glyphic.com>  Thu, 31 Jan 2019 19:36:50 -0800

contextfree (3.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Updated Standards-Version to 4.3.0.0
  * Fixed several lintian warnings: excluded files still present, no Vcs-*,
    upstream metadata

 -- John Horigan <john@glyphic.com>  Tue, 15 Jan 2019 21:11:31 -0800

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,21 @@
 Priority: optional
 Maintainer: John Horigan <john@glyphic.com>
 Uploaders: Paul van Tilburg <paulvt@debian.org>
-Build-Depends: debhelper (>= 10), flex (>= 2.6), bison (>=2:3), libpng-dev, libagg-dev (>= 1:2.4), libfl-dev (>= 2.6)
-Standards-Version: 4.1.0
+Build-Depends: debhelper (>= 10),
+               flex (>= 2.6),
+	       bison (>=2:3),
+	       libpng-dev,
+	       libagg2-dev (>= 1:2.6),
+	       libfl-dev (>= 2.6),
+	       libicu-dev (>= 57.1)
+Standards-Version: 4.3.0.0
 Homepage: https://www.contextfreeart.org/index.html
+Vcs-Browser: https://github.com/MtnViewJohn/context-free
+Vcs-git: https://github.com/MtnViewJohn/context-free.git
 
 Package: contextfree
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: libagg2 (>= 1:2.6), ${shlibs:Depends}, ${misc:Depends}
 Description: image generator based on context-free grammars
  Context Free is a program that produces images based on context-free grammars.
  These grammars are sets of non-deterministic rules that determine what an

## contextfree 3.2%2Bdfsg1

=== debian/changelog ===
contextfree (3.2+dfsg1-1ubuntu2) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:32:26 +0100

contextfree (3.2+dfsg1-1ubuntu1) focal; urgency=medium

  * Fix ftbfs due to missing includes.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 21 Feb 2020 21:40:44 +0000

contextfree (3.2+dfsg1-1build1) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 13 Feb 2020 08:55:13 +0100

contextfree (3.2+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Remove strip from Makefile so that dh_strip can do it instead.
    (Closes: #940662)
  * Updated Standards-Version to 4.4.0.1
  * Update debhelper to v12

 -- John Horigan <john@glyphic.com>  Mon, 23 Sep 2019 20:55:48 -0700

## contextfree 3.2+dfsg1

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Priority: optional
 Maintainer: John Horigan <john@glyphic.com>
 Uploaders: Paul van Tilburg <paulvt@debian.org>
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 12),
                flex (>= 2.6),
 	       bison (>=2:3),
 	       libpng-dev,
 	       libagg2-dev (>= 1:2.6),
 	       libfl-dev (>= 2.6),
 	       libicu-dev (>= 57.1)
-Standards-Version: 4.3.0.0
+Standards-Version: 4.4.0.1
 Homepage: https://www.contextfreeart.org/index.html
 Vcs-Browser: https://github.com/MtnViewJohn/context-free
 Vcs-git: https://github.com/MtnViewJohn/context-free.git

## contextfree 3.3%2Bdfsg1

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 vpath %.cpp $(SRC_DIRS)
 vpath %.cfdg input
 
-INC_DIRS = $(COMMON_DIR) $(UNIX_DIR) $(DERIVED_DIR) $(COMMON_DIR)/agg-extras $(FFMPEG_DIR)/include
+INC_DIRS = $(COMMON_DIR) $(UNIX_DIR) $(DERIVED_DIR) $(COMMON_DIR)/agg-extras
 INC_DIRS += /usr/local/include
 
 #
@@ -34,7 +34,7 @@
 # Library directories for FFmpeg and libpng
 #
 
-LIB_DIRS = $(FFMPEG_DIR)/lib /usr/local/lib
+LIB_DIRS = /usr/local/lib
 
 #
 # Sources and Objects
@@ -92,6 +92,7 @@
 #
 
 COMMON_SRCS += ffCanvasDummy.cpp
+
 SRCS = $(DERIVED_SRCS) $(COMMON_SRCS) $(UNIX_SRCS)
 
 #

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,28 @@
 Source: contextfree
 Section: graphics
 Priority: optional
-Maintainer: John Horigan <john@glyphic.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: John Horigan <john@glyphic.com>
 Uploaders: Paul van Tilburg <paulvt@debian.org>
-Build-Depends: debhelper (>= 12),
+Build-Depends: debhelper-compat (= 12),
                flex (>= 2.6),
 	       bison (>=2:3),
 	       libpng-dev,
-	       libagg2-dev (>= 1:2.6),
+	       libagg2-dev (>= 1:2.6.1),
 	       libfl-dev (>= 2.6),
-	       libicu-dev (>= 57.1)
-Standards-Version: 4.4.0.1
+	       libicu-dev (>= 57.1),
+	       libavformat-dev (>= 7:4.0),
+	       libswscale-dev (>= 7:4.0),
+	       libx264-dev (>= 2:0.155),
+Standards-Version: 4.5.0
 Homepage: https://www.contextfreeart.org/index.html
 Vcs-Browser: https://github.com/MtnViewJohn/context-free
 Vcs-git: https://github.com/MtnViewJohn/context-free.git
+Rules-Requires-Root: binary-targets
 
 Package: contextfree
 Architecture: any
-Depends: libagg2 (>= 1:2.6), ${shlibs:Depends}, ${misc:Depends}
+Depends: libagg2 (>= 1:2.6.1), ${shlibs:Depends}, ${misc:Depends}
 Description: image generator based on context-free grammars
  Context Free is a program that produces images based on context-free grammars.
  These grammars are sets of non-deterministic rules that determine what an

## contextfree 3.3+dfsg1

=== debian/changelog ===
contextfree (3.3+dfsg1-1build2) jammy; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 09 Feb 2022 05:39:12 +0100

contextfree (3.3+dfsg1-1build1) groovy; urgency=medium

  * No change rebuild against new icu ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 27 Jul 2020 16:40:02 +0100

contextfree (3.3+dfsg1-1) unstable; urgency=medium

  * New upstream release
  * Adds missing includes (Closes: #951939)
  * Uploaded package is source-only (Closes: #950882) (Closes: #953694)
  * Updated Standards-Version to 4.5.0 (no changes)
  * Enable optional QuickTime/FFmpeg support.

 -- John Horigan <john@glyphic.com>  Thu, 12 Mar 2020 12:44:17 -0700

=== debian/watch ===
version=4
options="pgpsigurlmangle=s%$%.asc%,dversionmangle=s/\+dfsg[0-9]*//,repacksuffix=+dfsg1" \
  https://www.contextfreeart.org/downloads.html \
  download/ContextFreeSource([\d\.]+)\.tar\.xz debian

## contextfree 3.4%2Bdfsg

=== debian/changelog ===
contextfree (3.4+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Remove FFmpeg patch, fix move to upstream.
  * Remove 01_* patch, moved upstream
  * Remaining patches updated to have DEP-3 compliant headers
  * Updated Standards-Version to 4.6.1 (no changes)

 -- John Horigan <john@glyphic.com>  Wed, 18 Jan 2023 15:52:13 -0800

contextfree (3.3+dfsg1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches: Fix build with ffmpeg 5.0 (Closes: #1004803)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 27 Feb 2022 17:03:40 +0100

## contextfree 3.4+dfsg

=== debian/changelog ===
contextfree (3.4+dfsg-1.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:39:48 +1100

contextfree (3.4+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop libagg2 runtime dependency (Closes: #1067428)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 21 Mar 2024 15:00:29 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: John Horigan <john@glyphic.com>
 Uploaders: Paul van Tilburg <paulvt@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                flex (>= 2.6),
 	       bison (>=2:3),
 	       libpng-dev,
@@ -14,15 +14,15 @@
 	       libavformat-dev (>= 7:4.0),
 	       libswscale-dev (>= 7:4.0),
 	       libx264-dev (>= 2:0.155),
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Homepage: https://www.contextfreeart.org/index.html
 Vcs-Browser: https://github.com/MtnViewJohn/context-free
-Vcs-git: https://github.com/MtnViewJohn/context-free.git
+Vcs-Git: https://github.com/MtnViewJohn/context-free.git
 Rules-Requires-Root: binary-targets
 
 Package: contextfree
 Architecture: any
-Depends: libagg2 (>= 1:2.6.1), ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: image generator based on context-free grammars
  Context Free is a program that produces images based on context-free grammars.
  These grammars are sets of non-deterministic rules that determine what an

## contextfree 3.4.2+dfsg

=== debian/changelog ===
contextfree (3.4.2+dfsg-1build5) resolute; urgency=medium

  * No-change rebuild for ffmpeg 8.

 -- Rik Mills <rikmills@kde.org>  Sun, 28 Dec 2025 10:50:24 +0000

contextfree (3.4.2+dfsg-1build4) resolute; urgency=medium

  * No-change rebuild for icu soname.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 02 Dec 2025 22:51:17 +0100

contextfree (3.4.2+dfsg-1build3) plucky; urgency=medium

  * No-change rebuild for fixed libagg2t64 dependency.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 13 Jan 2025 19:59:46 +0100

contextfree (3.4.2+dfsg-1build2) plucky; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 05 Jan 2025 20:29:16 +0100

contextfree (3.4.2+dfsg-1build1) oracular; urgency=medium

  * Rebuild against new libavcodec61.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 31 Jul 2024 17:11:17 +0200

contextfree (3.4.2+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #1072407)
  * Updated Standards-Version to 4.6.2 (no changes)

 -- John Horigan <john@glyphic.com>  Tue, 04 Jun 2024 00:10:09 -0700

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
 	       libavformat-dev (>= 7:4.0),
 	       libswscale-dev (>= 7:4.0),
 	       libx264-dev (>= 2:0.155),
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://www.contextfreeart.org/index.html
 Vcs-Browser: https://github.com/MtnViewJohn/context-free
 Vcs-Git: https://github.com/MtnViewJohn/context-free.git
